Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.

Bug 1281359

Summary: pcs does not support resource templates in CIB
Product: Red Hat Enterprise Linux 7 Reporter: Tomas Jelinek <tojeline>
Component: pcsAssignee: Tomas Jelinek <tojeline>
Status: NEW --- QA Contact: cluster-qe <cluster-qe>
Severity: unspecified Docs Contact:
Priority: medium    
Version: 7.2CC: cfeist, cluster-maint, jpokorny, kgaillot, nwahl, tojeline
Target Milestone: rcKeywords: FutureFeature
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:

Description Tomas Jelinek 2015-11-12 11:38:49 UTC
Support for resource templates is missing in pcs. It is not possible to manage resource templates and use them in constraints nor resource creation. Pcs is not able to properly manage resources referencing templates.

See Chapter 12. Resource Templates in Pacemaker Explained:
http://clusterlabs.org/doc/en-US/Pacemaker/1.1-pcs/html-single/Pacemaker_Explained/index.html#_configuring_resources_with_templates

Comment 1 Jan Pokorný [poki] 2015-11-26 17:26:33 UTC
This currently prevents "clufter ccs2pcscmd" emitting pcs commands of how
shared fence devices are encoded in CIB during the conversion process right
now (not that it cannot be changed, but it is inconvenient at the very
least).

Comment 3 Tomas Jelinek 2017-11-15 15:25:19 UTC
*** Bug 1513538 has been marked as a duplicate of this bug. ***

Comment 4 Jan Pokorný [poki] 2018-05-26 07:42:38 UTC
Similarly to [bug 1281358 comment 2], this could be worked around
using appropriate (currently non-existent) switch to cibadmin until
there's a proper support delivered in pcs.  Note that unline id-refs,
templates are first-class concept, substantially easier to present
to the users.

Re [comment 1]:
One of the options is to implement "template" exploding in XSLT,
which could then be reused as a filter in clufter easily, so
if the target pcs would be the one that doesn't resolve this
bug yet, it would resort to using that filter on the path
from CIB to pcs commands.

Comment 5 Jan Pokorný [poki] 2018-06-15 12:25:27 UTC
Templates _do_ get used -- as opposed to other syntanctic extensions
(extravagance); see the conclusion of the recent upstream community
survey (not very representative but at least some backing numbers):

https://lists.clusterlabs.org/pipermail/users/2018-June/015165.html